function [filedata] = StopShift_wrapper( file, neuron )
% clear
% clc

load(file);
% file = 'dummy';
% neuron = '01a';
eval(['SPK = SPK0', neuron, ';']); %SPK is now the cell of interest
Strobed_temp = Strobed;
first = min(SPK); %This is the first spike that was seen. Ignore all events up until this (for units that show up halfway through a session, useful for multiple trodes).
active = find(Strobed_temp(:,1) > first);
Strobed = Strobed_temp(active,:);

%Reconstructing the data structure from the strobes, creating a psth
%matrix!
% function data_plx = StopShift_wrapper(Strobed)

%First start recording (play)
%then start the task
%end the task
%end recording!

% stopi = 0;

%could be useful for psth time stamping!
try
    % find stamps from the strobe vector!
    strobedata = Strobed(:,2);
    timedata = Strobed(:,1);
    
    %subscript s for start and e for end
    Tstart = find(strobedata == 6001); %collect all stobes locs / adds specific to start of the task
    Tesc = find(strobedata == 6002 | strobedata == 6004 | strobedata == 6005);
    TTend = find(strobedata == 6003);%end
    TTitis = find(strobedata == 6010);%iti start
    Titie = find(strobedata == 6011);%iti end
    Tfixs = find(strobedata == 6020);%fix start
    Tfixe = find(strobedata == 6021);%fix end..ends at a variable fixation duration..actual start of Trial!
    Titi12s = find(strobedata == 6030);%iti12 start
    Titi12e = find(strobedata == 6031);%iti12 end
    Tgoofrs = find(strobedata == 6040);%go offer ppt start
    Tgocue = find(strobedata == 6041);%go cue appear before choice
    Tstopcue = find(strobedata == 6042);%stop cue appear before choice
    Tgoch_tt2 = find(strobedata == 6052);%go selected in task type 2
    Tgoch_tt1 = find(strobedata == 6053);%go selected in task type 1
    Tgoch_alttt2 = find(strobedata == 6054);%go selected  in task type 2 with alt targ
    Tgoch_alttt1 = find(strobedata == 6055);%go selected  in task type 1 with alt targ
    Tstopch_alttt2 = find(strobedata == 6056);%stop selected  in task type 2 with alt targ
    Tstopch_alttt1 = find(strobedata == 6057);%stop selected  in task type 1 with alt targ
    Tfdbks = find(strobedata == 6071);%fdbk started will end at 6003
    Trejch4 = find(strobedata == 6061);%reject trial of type 4 (was trying to fixate at the time of rejection)
    Trejch3 = find(strobedata == 6062); %reject trial of type 3(was not trying to fixate at the time of rejection)
    
    flag_start = [6001,6010];
    flag_stop = [6002:6005];
    flag_iti = [6010,6011];
    flag_fix = [6020,6021];
    flag_offer = [6040:6042];
    flag_choice = [6052:6062];
    flag_feedback = 6071;
    
    %find the number of starts and ends..should be same
    % disp('length(Tstart) - length(Tend) == 0');
    % (length(Titis) - length(Tend) == 0)
    %
    %     if ~isempty(Tstart)
    %make the iti less than end
    [Titis, Tend] = deal(TTitis, TTend);
    
    ind_new = 1;
    
    
    %LABELING as a trial only when it has all important stamps, such as
    %start, stop, iti, fix, offer, choice and feedback. else, they are
    %being thrown away
    for i = [1:length(Titis)]
        if i < length(Titis)
            
            tempind0 = [Titis(i):Titis(i+1)-1];
            tempind = strobedata(Titis(i):Titis(i+1)-1);
            
            fstart = any(ismember(flag_start,tempind));
            fstop = any(ismember(flag_stop,tempind));
            fiti = any(ismember(flag_iti,tempind));
            ffix = any(ismember(flag_fix,tempind));
            foffer = any(ismember(flag_offer,tempind));
            fchoice = any(ismember(flag_choice,tempind));
            ffeedback = any(ismember(flag_feedback,tempind));
            
            if [fstart && fstop && fiti && ffix && foffer && fchoice && ffeedback]
                Titis_new(ind_new) = Titis(i);
                Tend_new(ind_new) = intersect(tempind0,TTend);
                
                ind_new = ind_new +1;
            end
            
        else
            tempind0 = [Titis(i):length(strobedata)];
            tempind = strobedata(Titis(i):length(strobedata)-1);
            
            fstart = any(ismember(flag_start,tempind));
            fstop = any(ismember(flag_stop,tempind));
            fiti = any(ismember(flag_iti,tempind));
            ffix = any(ismember(flag_fix,tempind));
            foffer = any(ismember(flag_offer,tempind));
            fchoice = any(ismember(flag_choice,tempind));
            ffeedback = any(ismember(flag_feedback,tempind));
            
            if [fstart && fstop && fiti && ffix && foffer && fchoice && ffeedback]
                Titis_new(ind_new) = Titis(i);
                Tend_new(ind_new) = intersect(tempind0,TTend);
                
                ind_new = ind_new +1;
            end
            
        end
        
        
    end
    
    Titis = Titis_new;
    Tend = Tend_new;
    
    
    
    
    %Have to pick the Titis which is one index number ahead to Tstops... The
    %exception is whenever there are Tstarts! Those are only complete trials!
    %also remove the ones ending with a esc!
    
    %the itis has to be next to stop, or there could be a start at iti's place
    %next sanity check is to see if there are equal and equivalent pairs of
    %itis and ends
    
    
    
    nT = length(Tstart);
    psthbinsize = .020; %denote the msec step size of the final psth wanted
    totalspkt = 5000; %total length of a psth matrix
    
    %create a dummy NaN psth matrix with max time limits
    spkcol = nan(nT,totalspkt / psthbinsize);
    
    %ITI could be for 200 msec (a common number to that in rejected form..with
    %ch 3 and 4, and 1 sec with other forms of choices = 1 and 2)
    
    %     trialstart = input('Enter the trial start for this neuron');
    
    nulcol = [];
    
    for i = 1 : length(Titis) %[1:5,7:length(Titis)]
        i
        
        belongT{i} = [Titis(i):Tend(i)]'; %end of initial fixation to end of trial
        %ITI could be for around 400 msec before the fixe...that'd include the
        %process of fixation, and the ITI per say.
        itis = intersect(belongT{i},Titis);
        itie = intersect(belongT{i},Titie);
        titis = timedata(itis(1));%supposed to be a single scalar value
        titie = timedata(itie(end));
        
        fixs = intersect(belongT{i},Tfixs);
        fixe = intersect(belongT{i},Tfixe);
        
        tfixs = timedata(fixs(1));
        tfixe = timedata(fixe(end));
        
        if isempty(titie)
            titie = tfixs;
        end
        
        goofrs = intersect(belongT{i},Tgoofrs);
        goofre = intersect(belongT{i},Tgocue);
        tgoofrs = timedata(goofrs(1));
        
        
        if isempty(tfixe)
            tfixe = tgoofrs;
        end
        
        
        if ~isempty(goofre)
            tgoofre = timedata(goofre(1));
        end
        
        flag_stop = 0;
        %incase there is a stop cue, find the time stamp for it
        stopofrs = intersect(belongT{i},Tstopcue);
        if ~isempty(stopofrs)
            tstopofrs = timedata(stopofrs(1));
            flag_stop = 1;
            
            if isempty(goofre)
                tgoofre = timedata(stopofrs(1));
                
            end
        end
        
        che = intersect(belongT{i},[Tgoch_tt2;Tgoch_tt1;Tgoch_alttt2;...
            Tgoch_alttt1;Tstopch_alttt2;Tstopch_alttt1;Trejch4;Trejch3]);
        tche = timedata(che(1));
        fdbks = intersect(belongT{i}, Tfdbks);
        fdbke = Tend(i);
        tfdbks = timedata(fdbks(1));
        tfdbke = timedata(fdbke);
        
        %first find out the timings and the bins that they'd fall in the
        %vector (locked in time)
        
        %let the iti, fix, goofr, *stopofr,- ch, fdbk intratrial intervals be
        %numbered (labels) as 1,2,3,4,5,6
        
        
        if flag_stop == 0
            
            timeline = (0:psthbinsize:totalspkt) / psthbinsize;
            temp_cell = num2cell([titis,titie,tfixs,tfixe,tgoofrs,tgoofre,tche,tfdbks,tfdbke]-titis);
            [titis_1,titie_1,tfixs_1,tfixe_1,tgoofrs_1,tgoofre_1,tche_1,tfdbks_1,tfdbke_1]=deal(temp_cell{:});
            
            temp = find(timeline <= titis_1);
            titis_2 = temp(end);
            
            temp = find(timeline <= titie_1);
            titie_2 = temp(end);
            
            temp = find(timeline <= tfixs_1);
            tfixs_2 = temp(end);
            
            temp = find(timeline <= tfixe_1);
            tfixe_2 = temp(end);
            
            temp = find(timeline <= tgoofrs_1);
            tgoofrs_2 = temp(end);
            
            temp = find(timeline <= tgoofre_1);
            tgoofre_2 = temp(end);
            
            
            
            temp = find(timeline <= tche_1);
            tche_2 = temp(end);
            
            temp = find(timeline <= tfdbks_1);
            tfdbks_2 = temp(end);
            
            temp = find(timeline <= tfdbke_1);
            tfdbke_2 = temp(end);
            
            timeline_task = nan(size(timeline,1),size(timeline,2));
            
            
            timeline_task(titis_2:titie_2) = 1;
            timeline_task(tfixs_2:tfixe_2) = 2;
            timeline_task(tgoofrs_2:tgoofre_2) = 3;
            timeline_task(tgoofre_2:tche_2) = 5;
            timeline_task(tfdbks_2:tfdbke_2) = 6;
            
        else
            
            timeline = (0:psthbinsize:totalspkt) / psthbinsize;
            temp_cell = num2cell([titis,titie,tfixs,tfixe,tgoofrs,tgoofre,tstopofrs,tche,tfdbks,tfdbke]-titis);
            [titis_1,titie_1,tfixs_1,tfixe_1,tgoofrs_1,tgoofre_1,tstopofrs_1,tche_1,tfdbks_1,tfdbke_1]=deal(temp_cell{:});
            
            temp = find(timeline <= titis_1);
            titis_2 = temp(end);
            
            temp = find(timeline <= titie_1);
            titie_2 = temp(end);
            
            temp = find(timeline <= tfixs_1);
            tfixs_2 = temp(end);
            
            temp = find(timeline <= tfixe_1);
            tfixe_2 = temp(end);
            
            temp = find(timeline <= tgoofrs_1);
            tgoofrs_2 = temp(end);
            
            temp = find(timeline <= tgoofre_1);
            tgoofre_2 = temp(end);
            
            
            
            temp = find(timeline <= tche_1);
            tche_2 = temp(end);
            
            temp = find(timeline <= tfdbks_1);
            tfdbks_2 = temp(end);
            
            temp = find(timeline <= tfdbke_1);
            tfdbke_2 = temp(end);
            
            timeline_task = nan(size(timeline,1),size(timeline,2));
            
            
            temp = find(timeline <= tstopofrs_1);
            tstopofrs_2 = temp(end);
            
            timeline_task(titis_2:titie_2) = 1;
            timeline_task(tfixs_2:tfixe_2) = 2;
            timeline_task(tgoofrs_2:tgoofre_2) = 3;
            timeline_task(tstopofrs_2:tche_2) = 4; %****
            timeline_task(tgoofre_2:tche_2) = 5;
            timeline_task(tfdbks_2:tfdbke_2) = 6;
            
        end
        
        
        %find all the positions before the end of trial..
        dataa = [strobedata(belongT{i}(end-24:end-1))]'; %??
        datab = [0,27500,7250,7200,10000,12500,25000,7300,7400,15000,20000,22500,17500,7500,7600,7700,7800,7900,8000,8500,7001,7010,7020,7030];
        %REPLACE with nan if there ar 50's or 100's seen in the aray!!
        %and substract the datab
        dataab = dataa - datab;
        
        %substract the constants to some nan prone data params
        datac = 50; %[50, 500];
        indadd = [3,4,17,18, 19, 20, 6, 7, 10, 11, 12];
        
        tempind = find(dataab(1,indadd)== 0);%equate to nans
        
        dataab(1,indadd(tempind)) = nan;
        dataab(1,indadd) = dataab(1,indadd) - datac;
        
        %divide by constants to the multiplied data params
        %1000
        indmul1 = [5,6,7,10,11,12,13];
        datamul1 = [1000];
        %100
        indmul2 = [19,20];
        datamul2 = [100];
        
        %         indmul = [indmul1,indmul2];
        %         datamul = [datamul1,datamul2];
        
        %         [indmulxi] = find(dataab(1,indmul) == 0);
        %         dataab(1,indmul(indmulxi)) = nan;
        
        %         [indmul12] = setdiff([1:length(indmul)],indmulxi);
        %         dataab(1,indmul(indmul12)) = bsxfun(@rdivide,dataab(1,indmul(indmul12)),datamul(1,indmul12));
        dataab(1,indmul1) = dataab(1,indmul1)./datamul1;
        dataab(1,indmul2) = dataab(1,indmul2)./datamul2;
        
        
        data_beh(i,:) = dataab;
        
        %just collect key event timings of the trial, could be used for
        %psth matrix creation, aligned to that particular event!
        
        %events of interest:
        %iti, fix, go offer (fixed 200 msecs) and choice, feedback
        
        %6 and 7 are RT fix and RT targ in the data
        
        e1secs = 5;
        e2secs = 10;
        
        time = titis;
        starttime = time - e1secs;
        stoptime = time + e2secs;
        ixes=find(SPK>=starttime & SPK<=stoptime);
        rel_spikes=SPK(ixes);
        rel_spikes=rel_spikes-starttime;
        psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
        psth_itis(i,:)=psthline(1:end-1);
        
        time = tfixs;
        starttime = time - e1secs;
        stoptime = time + e2secs;
        ixes=find(SPK>=starttime & SPK<=stoptime);
        rel_spikes=SPK(ixes);
        rel_spikes=rel_spikes-starttime;
        psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
        psth_fixs(i,:)=psthline(1:end-1);
        
        time = tgoofrs;
        starttime = time - e1secs;
        stoptime = time + e2secs;
        ixes=find(SPK>=starttime & SPK<=stoptime);
        rel_spikes=SPK(ixes);
        rel_spikes=rel_spikes-starttime;
        psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
        psth_goofrs(i,:)=psthline(1:end-1);
        
        
        time = tgoofre;
        starttime = time - e1secs;
        stoptime = time + e2secs;
        ixes=find(SPK>=starttime & SPK<=stoptime);
        rel_spikes=SPK(ixes);
        rel_spikes=rel_spikes-starttime;
        psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
        psth_goofre(i,:)=psthline(1:end-1);
        
        
        
        time = tfdbks;
        starttime = time - e1secs;
        stoptime = time + e2secs;
        ixes=find(SPK>=starttime & SPK<=stoptime);
        rel_spikes=SPK(ixes);
        rel_spikes=rel_spikes-starttime;
        psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
        psth_fdbks(i,:)=psthline(1:end-1);
        
        %Added RT targ and RT quit at the end!
        
        %from the behavioral data!
        if flag_stop == 0
            data_time(i,:) = [titis,titie,tfixs,tfixe,tgoofrs,tgoofre,nan,tche,tfdbks,tfdbke,data_beh(i,6)+tgoofrs,data_beh(i,7)+tgoofrs];
            
            psth_stopofrs(i,:) = nan*ones(1,length([0:psthbinsize:e1secs+e2secs])-1);
            
        else
            data_time(i,:) = [titis,titie,tfixs,tfixe,tgoofrs,tgoofre,tstopofrs,tche,tfdbks,tfdbke,data_beh(i,6)+tgoofrs,data_beh(i,7)+tgoofrs];
            
            time = tstopofrs;
            starttime = time - e1secs;
            stoptime = time + e2secs;
            ixes=find(SPK>=starttime & SPK<=stoptime);
            rel_spikes=SPK(ixes);
            rel_spikes=rel_spikes-starttime;
            psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
            psth_stopofrs(i,:)=psthline(1:end-1);
            
            %         stopi = stopi + 1;
        end
        
        
        if ~isnan(data_beh(i,6)+tgoofrs)
            
            time = data_beh(i,6)+tgoofrs;
            starttime = time - e1secs;
            stoptime = time + e2secs;
            ixes=find(SPK>=starttime & SPK<=stoptime);
            rel_spikes=SPK(ixes);
            rel_spikes=rel_spikes-starttime;
            psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
            psth_rt(i,:)=psthline(1:end-1);
            
        else
            
            psth_rt(i,:)=nan*ones(1,size(psth_fdbks,2));
            
        end
        
        
        if ~isnan(data_beh(i,7)+tgoofrs)
            
            time = data_beh(i,7)+tgoofrs;
            starttime = time - e1secs;
            stoptime = time + e2secs;
            ixes=find(SPK>=starttime & SPK<=stoptime);
            rel_spikes=SPK(ixes);
            rel_spikes=rel_spikes-starttime;
            psthline=histc(rel_spikes,[0:psthbinsize:e1secs+e2secs]);
            psth_rtquit(i,:)=psthline(1:end-1);
            
        else
            
            psth_rtquit(i,:)=nan*ones(1,size(psth_fdbks,2));
            
            
        end
        
        
        if ~any([psth_itis(i,:),psth_fixs(i,:),psth_goofrs(i,:),psth_fdbks(i,:),psth_stopofrs(i,:)])
            
            nulcol = [nulcol,i];
        end
        
        
        
    end
    
    validcol = setdiff(1 : length(Titis),nulcol);
    
    filedata.name = [file,neuron];
    filedata.varsname = {'time.daysT+time.T'; 'time.T'; 'flag.choice'; 'flag.correct'; 'time.RTfix'; 'time.RTtarg';...
        'time.RTquit'; 'flag.tasktype';...
        'flag.alttarg'; 'time.Tssd';'time.Tssdact';'time.Tssdact0';'time.Tint12';...
        'flag.left'; 'sizes.Ngotarg'; 'color.Ngotarg';  'sizes.Nstoptarg';...
        'color.Nstoptarg';  'time.colorrew'; 'time.sizecost'; 'flag.gamble'; 'flag.gamblealt';...
        'flag.gamblerew'; 'flag.gamblerewalt'}; %4 more added at the end
    
    filedata.vars = data_beh(validcol,:);
    filedata.psthiti = psth_itis(validcol,:);
    filedata.psthfix = psth_fixs(validcol,:);
    
    filedata.psthofrs = psth_goofrs(validcol,:);
    filedata.psthofre = psth_goofre(validcol,:);
    
    filedata.psthfdbk = psth_fdbks(validcol,:);
    filedata.psthstopofr = psth_stopofrs(validcol,:);
    
    filedata.psthrt = psth_rt(validcol,:);
    filedata.psthrtquit = psth_rtquit(validcol,:);
    
    filedata.timeline = data_time(validcol,:);
    filedata.timelinenames = {'titis';'titie';'tfixs';'tfixe';'tgoofrs';'tgoofre';'tstopofrs';'tche';'tfdbks';'tfdbke';'t-RToffer';'t-RT quit'};
    
catch err
    keyboard
    %   rethrow(err)
    
end

% end
%the above have to be sorted out within the start and stop of a trial; and
%they have to be labelled accordingly within a trial [look up table against
%psth matrix)

%the following are params of interest, and they have to be stamped next to
%each other in a trial

end

%%% notes on psth binning:

%find the evens time lines..
%hist of all the data in betweeen that..histc with some bin size
%5 sec before event and 10 sec after event
%its a variable event?? what could be the time locking points?


